#ifndef RAM_H
#define RAM_H

/* see main.c for definition */

#ifndef RAM_FAST
static uint8 RAM[RAMSIZE];			// Definition of the emulated RAM

uint8* _RamSysAddr(uint16 address) {
	return(&RAM[address]);
}

uint8 _RamRead(uint16 address) {
	return(RAM[address]);
}

void _RamWrite(uint16 address, uint8 value) {
	RAM[address] = value;
}

void _RamWrite16(uint16 address, uint16 value) {
	// Z80 is a "little indian" (8 bit era joke)
	_RamWrite(address, value & 0xff);
	_RamWrite(address + 1, (value >> 8) & 0xff);
}
#endif

void _RamFill(uint16 address, int size, uint8 value) {
	while (size--)
		_RamWrite(address++, value);
}

void _RamCopy(uint16 source, int size, uint16 destination) {
	while (size--)
		_RamWrite(destination++, _RamRead(source++));
}

// ##### added by P.Z.
void _RamStr(char *p_source, uint16 destination) {
  do
    _RamWrite(destination++, (uint8)*p_source);
  while (*p_source++);
}
// ##### end

#endif
